class Hash
  def stringfy_key
    ret = collect do |k, v|
      key = k.to_s
      value = v.is_a?(Hash) ? v.stringfy_key : v
      [key, value]
    end
    Hash[ret]
  end

  def symbolize_key
    ret = collect do |k, v|
      key = k.to_sym
      value = v.is_a?(Hash) ? v.symbolize_key : v
      [key, value]
    end
    Hash[ret]
  end

  def stringfy_bool_value
    each_with_object({}) do |(k, v), r|
      next r[k] = v.stringfy_bool_value if v.is_a?(Hash)
      next r[k] = v.to_s if v == true || v == false
      r[k] = v
    end
  end

  def to_flatten_s
    to_a.map do |k, v|
      value = v
      value = "\"#{v}\"" if value.is_a?(String)
      value = v.to_flatten_s if value.is_a?(Hash)
      "#{k}:#{value}"
    end.join(',')
  end
end
class Symbol
  def to_colon_s
    %(:"#{self}")
  end
end

class String
  def to_quote_s
    %("#{self}")
  end
end

def desc(short, long)
  @desc ||= []
  @desc << [short, long]
end
