module DkComposer
  module Helper
    attr_accessor :build_path, :shortdesc, :longdesc
    def config(**opts)
      opts.each do |(key, value)|
        if value.is_a?(Array)
          send(key, *value)
        else
          send(key, value)
        end
      end
    end

    def shortdesc
      @shortdesc ||= @name
    end

    def longdesc
      @longdesc ||= @name
    end

    def deep_clone
      Marshal.load(Marshal.dump(self))
    end

    def build_path(path = nil)
      path ? @build_path = path : (@build_path ||= '.')
    end

    private

    def tempfile(content, *opts)
      tempfile = Tempfile.new(*opts)
      tempfile.write(content)
      tempfile.rewind
      tempfile.path.split('/').last
    end

    def run_command(command)
      system(command)
    end
  end
end
