module DkComposer
class Network
  include Composefile::Network
  include Helper
  attr_accessor :name, :fields
  def initialize(name)
    @name = name
    @fields={}
  end

  def to_h
    ret={}
    ret.merge!(@fields)
    ret={"#{name}":ret}
    ret.stringfy_key
  end

  def to_s
    ret= if @fields.empty?
      "network :#{name}"
    else
    <<-DUMP
      network(:#{name}) do
        #{
        fields.map do |(k,v)|
          v=v.to_quote_s if v.is_a?(String)
          v=v.map{|a| "'#{a}'"}.join(",") if v.is_a?(Array)
          "#{k} #{v.to_s}"
        end.join("\n")
        }
     end
    DUMP
  end
    ret
  end
  alias dump to_s

  def self.create(name,*params, **opts, &block)
    ret = new(name)
    ret.config(opts)
    ret.instance_exec(&block) if block
    ret
  end
end
end
def network(name,*params, **opts, &block)
  ret=DkComposer::Network.create(name,*params, **opts, &block)
  shortdesc, longdesc = (@desc || []).pop
  ret.shortdesc = shortdesc
  ret.longdesc = longdesc
  DkComposer::NETWORK[name] = ret
end
