

module DkComposer
class Service
  include Composefile::Service
  include Helper
  attr_accessor :image, :name,:fields
  def initialize(name)
    @name = name
    @fields={}
  end


  def image(name, **opt, &block)
    ret = if IMAGE[name]
      IMAGE[name].deep_clone
    else
      Image.create(name)
    end
    ret.config(opt)
    ret.instance_exec(&block) if block
    @image = ret
    ret
  end

  def to_h
    ret={image: @image.repo}
    ret.merge!(@fields)
    ret={"#{name}":ret}
    ret.stringfy_key
  end

  def run
    s=stack(:tmp_stack)
    s.config service: self.name
    s.run("-d")
  end

  def to_yaml
    to_h.to_yaml
  end

  def to_s
    image_name=if @image.name.is_a?(Symbol)
      @image.name.to_colon_s
    else
      %Q{"#{@image.name}"}
    end
    ret=<<-DUMP
     service(:#{name}) do
        image #{image_name}
        #{
        fields.map do |(k,v)|
          v=v.to_quote_s if v.is_a?(String)
          v=v.map{|a| "\"#{a}\""}.join(",") if v.is_a?(Array)
          v=v.to_flatten_s  if v.is_a?(Hash)
          "#{k} #{v.to_s}"
        end.join("\n")
        }
     end
    DUMP
    ret
  end
  alias dump to_s

  def self.create(name,*params,**opts, &block)
    ret = Service.new(name)
    ret.config opts
    ret.instance_exec(*params,&block) if block
    ret
  end
end
end
def service(name,*params,**opts, &block)
    ret=DkComposer::Service.create(name,*params,**opts,&block)
  shortdesc, longdesc = (@desc || []).pop
  ret.shortdesc = shortdesc
  ret.longdesc = longdesc
    
    DkComposer::SERVICE[name] = ret
    ret
end
